import { ModuleDescription, ModuleData, AdventureImage, CaptionImage } from "./IAdventure";
import { ModuleScene } from "./ModuleScene";
import { PdfData } from "../parse";
import { PageLayoutEmitFunction, PageLayout } from "./PageLayouts";
import * as EC from './extinctioncurse';
import { sentenceCase } from "./core";

const adventureModule : ModuleDescription = {
    prefix: "extinction-curse5",
    fullName: "Extinction Curse - Lord of the Black Sands",
    detect: (pdf: PdfData) => {
        return pdf.textDetails.some(t => t.text.trim() == 'EXTINCTION CURSE: LORD OF THE BLACK SANDS' && t.fontId == 'Gin-Regular:12');
    },
    extractDetails: EC.extractDetails,
    detectPageLayout: EC.detectPageLayout,
    pages: [
        // chapter 1
        new EC.ChapterHeadingPageLayout(6),
        new EC.RightSingleColumnWithSidebar(7),
        new EC.LeftTwoColumn(8),
        new EC.RightTwoColumn(9),
        new EC.LeftTwoColumnWithMap(10, 380),
        new EC.RightTwoColumn(11),
        new EC.LeftTwoColumn(12),
        new EC.RightTwoColumn(13),
        new EC.LeftTwoColumnWithLeftCutout(14, 70),
        new EC.RightTwoColumnWithRightCutout(15, 520),
        new EC.LeftTwoColumn(16),
        new EC.RightTwoColumnWithMap(17, 350),
        new EC.LeftTwoColumn(18),
        new EC.RightTwoColumn(19),
        new EC.LeftTwoColumnWithLeftCutout(20, 560),
        new EC.RightTwoColumn(21),
        new EC.LeftTwoColumn(22),
        new EC.RightTwoColumn(23),
        new EC.LeftTwoColumn(24),
        new EC.RightTwoColumn(25),

        // chapter 2
        new EC.ChapterHeadingPageLayout(26),
        new EC.RightSingleColumnWithSidebar(27),
        // map on 28
        new EC.RightTwoColumn(29),
        new EC.LeftTwoColumn(30),
        new EC.RightTwoColumn(31),
        new EC.LeftTwoColumn(32),
        new EC.RightTwoColumn(33),
        new EC.LeftTwoColumn(34),
        new EC.RightTwoColumn(35),
        new EC.LeftTwoColumn(36),
        new EC.RightTwoColumn(37),
        new EC.LeftTwoColumn(38),
        new EC.RightTwoColumn(39),
        new EC.LeftTwoColumn(40),
        new EC.RightTwoColumn(41),
        new EC.LeftTwoColumn(42),
        new EC.RightTwoColumn(43),
        
        // chapter 3
        new EC.ChapterHeadingPageLayout(44),
        new EC.RightSingleColumnWithSidebar(45),
        new EC.LeftTwoColumnWithLeftCutout(46, 320),
        new EC.RightTwoColumn(47),
        new EC.LeftTwoColumn(48),
        new EC.RightTwoColumn(49),
        new EC.LeftTwoColumn(50),
        new EC.RightTwoColumn(51),
        new EC.LeftTwoColumnWithMap(52, 340),
        new EC.RightTwoColumn(53),
        new EC.LeftTwoColumn(54),
        new EC.RightTwoColumn(55),
        new EC.LeftTwoColumn(56),
        new EC.RightTwoColumn(57),
        new EC.LeftTwoColumn(58),
        new EC.RightTwoColumn(59),
        new EC.LeftTwoColumn(60),
        new EC.RightTwoColumn(61),
        
        // appendix 1
        new EC.RightChapterHeadingPageLayout(63),
        // map on 64
        new EC.RightTwoColumnWithRightCutout(65, 340),
        new EC.LeftTwoColumn(66),
        new EC.RightTwoColumn(67),
        
        // appendix 2
        new EC.RightChapterHeadingPageLayout(69),
        new EC.LeftTwoColumnWithMap(70, 510),
        new EC.RightTwoColumnWithMap(71, 510),
        new EC.LeftTwoColumnWithMap(72, 510),
        new EC.RightTwoColumnWithMap(73, 510),
        
        // adventure toolbox
        new EC.RightChapterHeadingPageLayout(75),
        new EC.LeftTwoColumn(76),
        new EC.RightTwoColumn(77),
        new EC.LeftTwoColumn(78),
        new EC.RightSingleColumnWithSidebar(79),
        new EC.LeftSingleColumnWithSidebar(80),
        new EC.RightSingleColumnWithSidebar(81),
        new EC.LeftSingleColumnWithSidebar(82),
        new EC.RightSingleColumnWithSidebar(83),
        new EC.LeftSingleColumnWithSidebar(84),
        new EC.RightSingleColumnWithSidebar(85),
        new EC.LeftSingleColumnWithSidebar(86),
        new EC.RightSingleColumnWithSidebar(87),
        new EC.ChapterHeadingPageLayout(88),
        new EC.RightTwoColumn(89),
        new EC.ChapterHeadingPageLayout(90),
        new EC.RightTwoColumn(91),
        new EC.ChapterHeadingPageLayout(92),
        new EC.RightTwoColumn(93),        
    ],
    scenes: [
        new ModuleScene({
            name: 'map1',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 10, width: 1261, height: 805,
            gridType: 'gridless',
            imageLeft: 0, imageRight: 1000, imageCols: 10,
            imageTop: 0, imageBottom: 1000, imageRows: 10,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map2',
            nameInfo: { x: 75, y: 694.8362 },
            nameFn: name => sentenceCase(name),
            page: 11, width: 635, height: 803,
            imageLeft: 75, imageRight: 569, imageCols: 20,
            imageTop: 23, imageBottom: 789, imageRows: 31,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map3a',
            nameInfo: { x: 186, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 14, width: 645, height: 1636,
            cropLeft: 0, cropRight: 645, cropTop: 0, cropBottom: 825,
            imageLeft: 39, imageRight: 618, imageCols: 22,
            imageTop: 10, imageBottom: 747, imageRows: 28,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map3b',
            nameInfo: { x: 186, y: 366.3362 },
            nameFn: name => sentenceCase(name),
            page: 14, width: 645, height: 1636,
            cropLeft: 0, cropRight: 645, cropTop: 830, cropBottom: 1636,
            imageLeft: 17, imageRight: 637, imageCols: 24,
            imageTop: 842, imageBottom: 1616, imageRows: 30,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map4',
            nameInfo: { x: 75, y: 694.8362 },
            nameFn: name => sentenceCase(name),
            page: 17, width: 910, height: 705,
            imageLeft: 20, imageRight: 900, imageCols: 43,
            imageTop: 10, imageBottom: 686, imageRows: 33,
            globalLight: true,
        }),

        new ModuleScene({
            name: 'map5a',
            nameInfo: { x: 15.75, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 28, width: 1261, height: 1637,
            cropLeft: 17, cropRight: 389, cropTop: 8, cropBottom: 515,
            imageLeft: 17, imageRight: 389, imageCols: 28,
            imageTop: 8, imageBottom: 515, imageRows: 38,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map5b',
            nameInfo: { x: 203, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 28, width: 1261, height: 1637,
            cropLeft: 405, cropRight: 818, cropTop: 10, cropBottom: 517,
            imageLeft: 405, imageRight: 818, imageCols: 31,
            imageTop: 10, imageBottom: 517, imageRows: 38,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map5c',
            nameInfo: { x: 406, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 28, width: 1261, height: 1637,
            cropLeft: 842, cropRight: 1253, cropTop: 9, cropBottom: 516,
            imageLeft: 842, imageRight: 1253, imageCols: 31,
            imageTop: 9, imageBottom: 516, imageRows: 38,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map5d',
            nameInfo: { x: 15.75, y: 513.5862 },
            nameFn: name => sentenceCase(name),
            page: 28, width: 1261, height: 1637,
            cropLeft: 3, cropRight: 656, cropTop: 530, cropBottom: 1156,
            imageLeft: 3, imageRight: 656, imageCols: 49,
            imageTop: 542, imageBottom: 1156, imageRows: 46,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map5e',
            nameInfo: { x: 332.25, y: 513.5862 },
            nameFn: name => sentenceCase(name),
            page: 28, width: 1261, height: 1637,
            cropLeft: 683, cropRight: 1255, cropTop: 541, cropBottom: 1156,
            imageLeft: 683, imageRight: 1255, imageCols: 43,
            imageTop: 541, imageBottom: 1156, imageRows: 46,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map5f',
            nameInfo: { x: 10.75, y: 199.6681 },
            nameFn: name => sentenceCase(name),
            page: 28, width: 1261, height: 1637,
            cropLeft: 4, cropRight: 284, cropTop: 1182, cropBottom: 1622,
            imageLeft: 4, imageRight: 284, imageCols: 21,
            imageTop: 1182, imageBottom: 1622, imageRows: 33,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map5g',
            nameInfo: { x: 166.5, y: 199.6681 },
            nameFn: name => sentenceCase(name),
            page: 28, width: 1261, height: 1637,
            cropLeft: 310, cropRight: 710, cropTop: 1182, cropBottom: 1623,
            imageLeft: 310, imageRight: 710, imageCols: 30,
            imageTop: 1182, imageBottom: 1623, imageRows: 33,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map5h',
            nameInfo: { x: 371.25, y: 206.5862 },
            nameFn: name => sentenceCase(name),
            page: 28, width: 1261, height: 1637,
            cropLeft: 737, cropRight: 1256, cropTop: 1182, cropBottom: 1636,
            imageLeft: 737, imageRight: 1256, imageCols: 39,
            imageTop: 1182, imageBottom: 1636, imageRows: 34,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map6',
            nameInfo: { x: 16.5, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 52, width: 1260, height: 880,
            imageLeft: 69, imageRight: 1179, imageCols: 44,
            imageTop: 140, imageBottom: 821, imageRows: 27,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map7',
            nameInfo: { x: 23, y: 755.8362 },
            nameFn: name => sentenceCase(name),
            page: 64, width: 1261, height: 1636,
            gridType: 'gridless',
            imageLeft: 0, imageRight: 1000, imageCols: 10,
            imageTop: 0, imageBottom: 1000, imageRows: 10,
            globalLight: true,
        }),
    ],
    journals: [
        new AdventureImage({ name: 'journal1', page: 2, width: 589, height: 809, index: 0 }),
        new AdventureImage({ name: 'journal2', page: 2, width: 589, height: 809, index: 1 }),
        new AdventureImage({ name: 'journal3', page: 2, width: 589, height: 809, index: 2 }),
        new AdventureImage({ name: 'journal4', page: 2, width: 589, height: 809, index: 3 }),
        new AdventureImage({ name: 'journal5', page: 2, width: 589, height: 809, index: 4 }),
        new AdventureImage({ name: 'journal6', page: 2, width: 589, height: 809, index: 5 }),
        new AdventureImage({ name: 'journal7', page: 4, width: 1261, height: 1637 }),
        new AdventureImage({ name: 'journal8', page: 6, width: 1259, height: 805 }),
        new CaptionImage({ name: 'journal9', page: 15, width: 839, height: 1221 }),
        new AdventureImage({ name: 'journal10', page: 26, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal11', page: 44, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal12', page: 45, width: 564, height: 543 }),
        new AdventureImage({ name: 'journal13', page: 62, width: 1261, height: 1637 }),
        new AdventureImage({ name: 'journal14', page: 68, width: 1261, height: 1636 }),
        new AdventureImage({ name: 'journal15', page: 74, width: 1261, height: 1636 }),
        new AdventureImage({ name: 'journal16', page: 77, width: 453, height: 450 }),
        new AdventureImage({ name: 'journal17', page: 78, width: 646, height: 646 }),

        new CaptionImage({ name: 'npc1', page: 8, width: 564, height: 543 }),
        new CaptionImage({ name: 'npc2', page: 9, width: 569, height: 569 }),
        new CaptionImage({ name: 'npc3', page: 12, width: 873, height: 1235 }),
        new CaptionImage({ name: 'npc4', page: 19, width: 903, height: 910 }),
        new CaptionImage({ name: 'npc5', page: 23, width: 580, height: 580 }),
        new CaptionImage({ name: 'npc6', page: 25, width: 856, height: 1164 }),
        new CaptionImage({ name: 'npc7', page: 31, width: 1180, height: 838 }),
        new CaptionImage({ name: 'npc8', page: 35, width: 930, height: 1117 }),
        new CaptionImage({ name: 'npc9', page: 38, width: 903, height: 1161 }),
        new CaptionImage({ name: 'npc10', page: 39, width: 818, height: 1111 }),
        new CaptionImage({ name: 'npc11', page: 41, width: 903, height: 1253 }),
        new CaptionImage({ name: 'npc12', page: 47, width: 605, height: 638 }),
        new CaptionImage({ name: 'npc13', page: 49, width: 606, height: 646 }),
        new CaptionImage({ name: 'npc14', page: 50, width: 600, height: 600 }),
        new CaptionImage({ name: 'npc15', page: 51, width: 766, height: 1219 }),
        new CaptionImage({ name: 'npc16', page: 53, width: 798, height: 1353 }),
        new CaptionImage({ name: 'npc17', page: 54, width: 770, height: 1210 }),
        new CaptionImage({ name: 'npc18', page: 55, width: 606, height: 1120 }),
        new CaptionImage({ name: 'npc19', page: 57, width: 867, height: 1161 }),
        new CaptionImage({ name: 'npc20', page: 59, width: 851, height: 1273 }),
        new CaptionImage({ name: 'npc21', page: 61, width: 803, height: 1261 }),
        new CaptionImage({ name: 'npc22', page: 66, width: 567, height: 600 }),
        new CaptionImage({ name: 'npc23', page: 67, width: 564, height: 600 }),
        new CaptionImage({ name: 'npc24', page: 70, width: 369, height: 369 }),
        new CaptionImage({ name: 'npc25', page: 71, width: 404, height: 404 }),
        new CaptionImage({ name: 'npc26', page: 72, width: 425, height: 425 }),
        new CaptionImage({ name: 'npc27', page: 73, width: 400, height: 400 }),
        new CaptionImage({ name: 'npc28', page: 79, width: 953, height: 970 }),
        new CaptionImage({ name: 'npc29', page: 80, width: 764, height: 1078 }),
        new CaptionImage({ name: 'npc30', page: 81, width: 872, height: 1030 }),
        new CaptionImage({ name: 'npc31', page: 82, width: 919, height: 1123 }),
        new CaptionImage({ name: 'npc32', page: 83, width: 800, height: 1034 }),
        new CaptionImage({ name: 'npc33', page: 84, width: 655, height: 1101 }),
        new CaptionImage({ name: 'npc34', page: 85, width: 703, height: 1123 }),
        new CaptionImage({ name: 'npc35', page: 86, width: 699, height: 1035 }),
        new CaptionImage({ name: 'npc36', page: 87, width: 915, height: 1154 }),
        new CaptionImage({ name: 'npc37', page: 89, width: 824, height: 1285 }),
        new CaptionImage({ name: 'npc38', page: 91, width: 919, height: 1289 }),
        new CaptionImage({ name: 'npc39', page: 93, width: 774, height: 1062 }),
    ],
    finalize: (moduleData: ModuleData) => {
    }
};

export default adventureModule;